(() => {
    var autoscan = true;

    const getChildDocuments = (rootDocument) => {
        if (!rootDocument) {
            return [];
        }
        let iframes = Array.prototype.slice.call(rootDocument.getElementsByTagName("iframe"), 0);
        let documents = [];
        for (let i = 0; i < iframes.length; i++) {
            if (iframes[i].contentDocument) {
                documents.push(iframes[i].contentDocument);
                documents = documents.concat(getChildDocuments(iframes[i].contentDocument));
            }
        }
        return documents;
    };

    const getAllDocuments = (() => {
        return getChildDocuments(document).concat(document);
    });

    chrome.runtime.onMessage.addListener((msg, sender, response) => {
        if (chrome.runtime.lastError) {
            console.warn(chrome.runtime.lastError.message);
        }
        if ( msg.subject == 'autoscan' ) {
            autoscan = msg.activate
            return true;
        }
        else {
            window.postMessage(msg, location.href);
            return true;
        }

    });

    chrome.runtime.sendMessage({}, (response) => {
        if (chrome.runtime.lastError) {
            console.warn(chrome.runtime.lastError.message);
        }

        const useOverlayMode = () => {
            // NOTE(jochen): We always use Overlay Mode from now on...
            return true;
        };

        const readyStateCheckInterval = setInterval(() => {
            if (document.readyState === "complete") {
                Settings.load((settings) => {
                    Settings.resolveActivationMap(settings, document.location.href);

                    settings.language = navigator.language.substring(0, 2);
                    settings.overlayMode = false;
                    settings.hideStatusPanel = true;

                    const injectedElements = [];

                    var injectSpellcheckers = () => {
                        if ( !autoscan) return;
                        if (!settings.activated) {
                            Settings.load((s) => {
                                settings = s;
                                settings.language = navigator.language.substring(0, 2);
                                settings.overlayMode = false;
                                Settings.resolveActivationMap(settings, document.location.href);
                            });
                            return;
                        }

                        const documents = getAllDocuments();
                        for (let i = 0; i < documents.length; ++i) {
                            //var elementsToInjectDKCE = documents[i].querySelectorAll("[contenteditable='true'], textarea");
                            var elementsToInjectDKCE = documents[i].querySelectorAll("[contenteditable='true']");

                            for (let j = 0; j < elementsToInjectDKCE.length; ++j) {
                                if (elementsToInjectDKCE[j].classList.contains("dkce-element")) {
                                    continue;
                                }

                                if (document.body.id === "statamic") {
                                    settings.overlayMode = true;
                                    if (elementsToInjectDKCE[j].classList.contains("bard-source")) continue;
                                    if (elementsToInjectDKCE[j].classList.contains("search")) continue;
                                    if (elementsToInjectDKCE[j].classList.contains("new-item")) continue;
                                    if (elementsToInjectDKCE[j].parentNode && elementsToInjectDKCE[j].parentNode.parentNode && elementsToInjectDKCE[j].parentNode.parentNode.classList.contains("CodeMirror")) continue;
                                } else if (useOverlayMode()) {
                                    settings.overlayMode = true;
                                }

                                if (!injectedElements.includes(elementsToInjectDKCE[j])) {
                                    injectedElements.push(elementsToInjectDKCE[j]);
                                    DKCE.init(elementsToInjectDKCE[j], settings);
                                }
                            }
                        }
                    }

                    injectSpellcheckers();
                    window.setInterval(injectSpellcheckers, 2000);
                });
                clearInterval(readyStateCheckInterval);
            }
        }, 10);
    });
})();
